## irgsh 0.0.28-1

=== Makefile ===
LDFLAGS := "-X main.version=$$(cat ./VERSION)"

release:
	# Build
	make build
	# Bundling
	mkdir -p irgsh-go/usr/bin
	mkdir -p irgsh-go/etc/irgsh
	mkdir -p irgsh-go/etc/init.d
	mkdir -p irgsh-go/lib/systemd/system
	mkdir -p irgsh-go/usr/share/irgsh
	cp -rf bin/* irgsh-go/usr/bin/
	cp -rf utils/config.yaml irgsh-go/etc/irgsh/
	cp -rf utils/config.yaml irgsh-go/usr/share/irgsh/config.yaml
	cp -rf utils/init/* irgsh-go/etc/init.d/
	cp -rf utils/systemctl/* irgsh-go/lib/systemd/system
	cp -rf utils/scripts/init.sh irgsh-go/usr/share/irgsh/init.sh
	cp -rf -R utils/reprepro-template irgsh-go/usr/share/irgsh/reprepro-template
	tar -zcvf release.tar.gz irgsh-go
	mkdir -p target
	mv release.tar.gz target/

release-in-docker: release
	# It's possible this release command will be used inside a container
	# Let it rewriteable for host environment
	chmod -vR a+rw target
	chown -vR :users target

preinstall:
	sudo /etc/init.d/irgsh-chief stop || true
	sudo /etc/init.d/irgsh-builder stop || true
	sudo /etc/init.d/irgsh-iso stop || true
	sudo /etc/init.d/irgsh-repo stop || true
	sudo killall irgsh-chief || true
	sudo killall irgsh-builder || true
	sudo killall irgsh-iso || true
	sudo killall irgsh-repo || true

build-in-docker:
	cp -rf utils/docker/build/Dockerfile .
	docker build --no-cache -t irgsh-build .
	docker run -v $(pwd)/target:/tmp/src/target irgsh-build make release-in-docker

build:
	mkdir -p bin
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-chief ./cmd/chief
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-iso ./cmd/iso
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-cli ./cmd/cli

build-install: release
	./install.sh
	sudo systemctl daemon-reload
	sudo /lib/systemd/systemd-sysv-install enable irgsh-chief
	sudo /lib/systemd/systemd-sysv-install enable irgsh-builder
	sudo /lib/systemd/systemd-sysv-install enable irgsh-repo
	sudo systemctl start irgsh-chief
	sudo systemctl start irgsh-builder
	sudo systemctl start irgsh-repo

test:
	mkdir -p tmp
	go test -race -coverprofile=coverage.txt -covermode=atomic ./cmd/builder
	go test -race -coverprofile=coverage.txt -covermode=atomic ./cmd/iso
	go test -race -coverprofile=coverage.txt -covermode=atomic ./cmd/repo

coverage:test
	go tool cover -html=coverage.txt

client:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-cli ./cmd/cli

chief:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-chief ./cmd/chief && DEV=1 ./bin/irgsh-chief

builder-init:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && sudo DEV=1 ./bin/irgsh-builder init-base
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && DEV=1 ./bin/irgsh-builder init-builder

builder:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && DEV=1 ./bin/irgsh-builder

iso:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-iso ./cmd/iso && DEV=1 ./bin/irgsh-iso

repo-init:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo init

repo:
	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo

redis:
	docker run -d --network host redis

submit:
	curl --header "Content-Type: application/json" --request POST --data '{"sourceUrl":"https://github.com/BlankOn/bromo-theme.git","packageUrl":"https://github.com/BlankOn-packages/bromo-theme.git"}' http://localhost:8080/api/v1/submit

deb:
	debuild -us -uc -b

=== debian/changelog ===
irgsh (0.0.28-1) unstable; urgency=medium

  * Initial Debian package release
  * Package all IRGSH components (chief, builder, repo, iso, cli)
  * Include systemd service files for server components
  * Add configuration files and templates

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Wed, 07 Jan 2026 21:00:00 +0700

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

# Enable Go modules
export GO111MODULE = on
export GOPROXY = https://proxy.golang.org,direct

# Read version from VERSION file
VERSION := $(shell cat VERSION)
LDFLAGS := -X main.version=$(VERSION)

%:
	dh $@

override_dh_auto_clean:
	rm -rf bin obj-x86_64-linux-gnu cli
	dh_auto_clean

override_dh_auto_build:
	# Download dependencies
	go mod download
	# Build all binaries with version info
	mkdir -p bin
	go build -ldflags "$(LDFLAGS)" -o bin/irgsh-repo ./cmd/repo
	go build -ldflags "$(LDFLAGS)" -o bin/irgsh-chief ./cmd/chief
	go build -ldflags "$(LDFLAGS)" -o bin/irgsh-builder ./cmd/builder
	go build -ldflags "$(LDFLAGS)" -o bin/irgsh-iso ./cmd/iso
	go build -ldflags "$(LDFLAGS)" -o bin/irgsh-cli ./cmd/cli

override_dh_auto_test:
	# Skip tests during package build
	@echo "Skipping tests"

override_dh_dwz:
	# Skip dwz compression for Go binaries
	@echo "Skipping dwz for Go binaries"

override_dh_strip:
	# Don't strip Go binaries to preserve panic stack traces
	dh_strip --no-automatic-dbgsym

override_dh_auto_install:
	# Install binaries
	install -D -m 0755 bin/irgsh-repo $(CURDIR)/debian/irgsh/usr/bin/irgsh-repo
	install -D -m 0755 bin/irgsh-chief $(CURDIR)/debian/irgsh/usr/bin/irgsh-chief
	install -D -m 0755 bin/irgsh-builder $(CURDIR)/debian/irgsh/usr/bin/irgsh-builder
	install -D -m 0755 bin/irgsh-iso $(CURDIR)/debian/irgsh/usr/bin/irgsh-iso
	install -D -m 0755 bin/irgsh-cli $(CURDIR)/debian/irgsh/usr/bin/irgsh-cli
	# Install systemd service files
	install -D -m 0644 debian/irgsh-chief.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-chief.service
	install -D -m 0644 debian/irgsh-builder.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-builder.service
	install -D -m 0644 debian/irgsh-repo.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-repo.service
	install -D -m 0644 debian/irgsh-iso.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-iso.service
	# Install configuration files
	install -D -m 0644 utils/config.yml $(CURDIR)/debian/irgsh/etc/irgsh/config.yml
	install -D -m 0644 utils/config.yml $(CURDIR)/debian/irgsh/usr/share/irgsh/config.yml
	# Install init script
	install -D -m 0755 utils/scripts/init.sh $(CURDIR)/debian/irgsh/usr/share/irgsh/init.sh
	# Install reprepro template
	mkdir -p $(CURDIR)/debian/irgsh/usr/share/irgsh/reprepro-template
	cp -r utils/reprepro-template/* $(CURDIR)/debian/irgsh/usr/share/irgsh/reprepro-template/
	# Create necessary directories
	mkdir -p $(CURDIR)/debian/irgsh/var/lib/irgsh
	mkdir -p $(CURDIR)/debian/irgsh/var/log/irgsh

override_dh_installsystemd:
	# Install systemd services but don't enable them by default
	dh_installsystemd --no-enable --no-start

## irgsh 1.0.0-1

=== debian/changelog ===
irgsh (1.0.0-1) unstable; urgency=medium

  * Major release: Version 1.0.0
  * Migrate all .yml extensions to .yaml for consistency
  * Update all configuration file references from .yml to .yaml
  * Add git repository links to job monitoring dashboard
  * Implement stage-level failure detection (build vs repo)
  * Improve monitoring dashboard UI and layout

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Wed, 08 Jan 2026 16:00:00 +0700

=== debian/rules ===
--- 
+++ 
@@ -53,8 +53,8 @@
 	install -D -m 0644 debian/irgsh-repo.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-repo.service
 	install -D -m 0644 debian/irgsh-iso.service $(CURDIR)/debian/irgsh/lib/systemd/system/irgsh-iso.service
 	# Install configuration files
-	install -D -m 0644 utils/config.yml $(CURDIR)/debian/irgsh/etc/irgsh/config.yml
-	install -D -m 0644 utils/config.yml $(CURDIR)/debian/irgsh/usr/share/irgsh/config.yml
+	install -D -m 0644 utils/config.yaml $(CURDIR)/debian/irgsh/etc/irgsh/config.yaml
+	install -D -m 0644 utils/config.yaml $(CURDIR)/debian/irgsh/usr/share/irgsh/config.yaml
 	# Install init script
 	install -D -m 0755 utils/scripts/init.sh $(CURDIR)/debian/irgsh/usr/share/irgsh/init.sh
 	# Install reprepro template

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/irgsh-go-$1\.tar\.gz/ \
  https://github.com/BlankOn/irgsh-go/tags .*/v?(\d\S+)\.tar\.gz

## irgsh 1.2.4-1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,20 @@
 LDFLAGS := "-X main.version=$$(cat ./VERSION)"
+
+# Load GPG_KEY from .env and update config.yaml
+load-gpg:
+	@if [ -f .env ]; then \
+		GPG_KEY=$$(grep '^GPG_KEY=' .env | cut -d'=' -f2); \
+		if [ -n "$$GPG_KEY" ]; then \
+			sed -i "s/dist_signing_key: '.*'/dist_signing_key: '$$GPG_KEY'/" utils/config.yaml; \
+			echo "Loaded GPG_KEY: $$GPG_KEY"; \
+		else \
+			echo "GPG_KEY not found in .env"; \
+			exit 1; \
+		fi \
+	else \
+		echo ".env file not found"; \
+		exit 1; \
+	fi
 
 release:
 	# Build
@@ -68,14 +84,18 @@
 coverage:test
 	go tool cover -html=coverage.txt
 
-client:
-	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-cli ./cmd/cli
+client: load-gpg
+	@GPG_KEY=$$(grep '^GPG_KEY=' .env | cut -d'=' -f2); \
+	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-cli ./cmd/cli && DEV=1 ./bin/irgsh-cli config --chief http://localhost:8080 --key $$GPG_KEY
 
-chief:
+chief: load-gpg
 	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-chief ./cmd/chief && DEV=1 ./bin/irgsh-chief
 
 builder-init:
 	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && sudo DEV=1 ./bin/irgsh-builder init-base
+	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && DEV=1 ./bin/irgsh-builder init-builder
+
+builder-init-builder:
 	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-builder ./cmd/builder && DEV=1 ./bin/irgsh-builder init-builder
 
 builder:
@@ -85,10 +105,10 @@
 	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-iso ./cmd/iso && DEV=1 ./bin/irgsh-iso
 
 repo-init:
-	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo init
+	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo --config ./utils/config.yaml init
 
-repo:
-	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo
+repo: load-gpg
+	go build -ldflags $(LDFLAGS) -o ./bin/irgsh-repo ./cmd/repo && DEV=1 ./bin/irgsh-repo --config ./utils/config.yaml
 
 redis:
 	docker run -d --network host redis
@@ -97,5 +117,6 @@
 	curl --header "Content-Type: application/json" --request POST --data '{"sourceUrl":"https://github.com/BlankOn/bromo-theme.git","packageUrl":"https://github.com/BlankOn-packages/bromo-theme.git"}' http://localhost:8080/api/v1/submit
 
 deb:
+	sudo rm -rf obj-x86_64-linux-gnu
 	debuild -us -uc -b

=== debian/changelog ===
irgsh (1.2.4-1) unstable; urgency=medium

  * Show 50 jobs on front page instead of 10
  * Display timestamps in Asia/Jakarta timezone with relative time
  * Add STALLED status for jobs pending more than 24 hours
  * Simplify notification message format
  * Fix OOM issue when uploading large tarballs by streaming to disk

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Sat, 11 Jan 2026 19:00:00 +0700

irgsh (1.2.3-1) unstable; urgency=medium

  * Fix retry permission issue by using sudo for copy operations
  * Restore ownership to irgsh user after copying submission files

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Sat, 11 Jan 2026 18:00:00 +0700

irgsh (1.2.2-1) unstable; urgency=medium

  * Retry creates new pipeline with new job ID and timestamp
  * Add emoji indicators to job notifications (success/failed)

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Sat, 11 Jan 2026 17:00:00 +0700

irgsh (1.2.1-1) unstable; urgency=medium

  * Add notification webhook support for build and repo job completion
  * Require explicit config path for irgsh-repo via -c/--config flag
  * Add LoadConfigFromPath function for explicit config loading

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Fri, 10 Jan 2026 19:00:00 +0700

irgsh (1.1.5-1) unstable; urgency=medium

  * Allow --ignore-checks without --experimental flag

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Fri, 10 Jan 2026 11:00:00 +0700

irgsh (1.1.4-1) unstable; urgency=medium

  * Update --ignore-checks help text

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Fri, 10 Jan 2026 10:00:00 +0700

irgsh (1.1.3-1) unstable; urgency=medium

  * Release 1.1.3

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Thu, 09 Jan 2026 18:00:00 +0700

irgsh (1.1.2-1) unstable; urgency=medium

  * Use machinery backend for job status queries
  * Remove STALLED status from frontend
  * Rename Recent Jobs to Recent Packaging Jobs
  * Remove Instance column from Workers table

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Thu, 09 Jan 2026 16:00:00 +0700

irgsh (1.1.1-1) unstable; urgency=medium

  * Fix retry endpoint error handling in CLI
  * Fix HTTP router prioritization in chief
  * Fix pipeline status to show DONE when repo job completes

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Thu, 09 Jan 2026 14:00:00 +0700

irgsh (1.1.0-1) unstable; urgency=medium

  * Add STALLED status for jobs pending > 5 minutes while workers are online

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Thu, 09 Jan 2026 12:00:00 +0700

=== debian/control ===
Source: irgsh
Section: devel
Priority: optional
Maintainer: BlankOn Developers <blankon-dev@googlegroups.com>
Build-Depends: debhelper-compat (= 13),
               golang-go (>= 2:1.13~)
Standards-Version: 4.6.0
Homepage: https://github.com/BlankOn/irgsh-go
Vcs-Browser: https://github.com/BlankOn/irgsh-go
Vcs-Git: https://github.com/BlankOn/irgsh-go.git

Package: irgsh
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser
Recommends: gpg,
            devscripts,
            redis-server | redis
Suggests: pbuilder,
          debootstrap,
          reprepro,
          dh-make,
          docker.io | docker-ce
Description: All-in-one tool for Debian-derived distribution maintenance
 IRGSH (pronunciation: irgis) is an all-in-one tool to create and maintain
 Debian-derived GNU/Linux distribution: from packaging to repository, from
 ISO build to release management.
 .
 This package contains all IRGSH server components:
  * irgsh-chief - acts as the master controller
  * irgsh-builder - builder worker for package building
  * irgsh-repo - repository server for package storage
  * irgsh-iso - ISO image builder
  * irgsh-cli - command-line client tool for package maintainers
 .
 A minimal IRGSH ecosystem requires irgsh-chief, irgsh-builder, and
 irgsh-repo services running, along with a Redis server for task queuing.

## irgsh 1.2.5-1

=== debian/changelog ===
irgsh (1.2.5-1) unstable; urgency=medium

  * Fix OOM issue in artifact upload by streaming to disk

 -- BlankOn Developers <blankon-dev@googlegroups.com>  Sun, 12 Jan 2026 04:00:00 +0700
